AOZ Studio Beta - Bug #132

Font$ is messed up in Amiga mode (several problems, but all related)

02/05/2020 04:48 PM - Brian Flanagan

Status: New Start date: 02/05/2020
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 2:00 hours
Target version:

Affected version: 1.0.0 (B3)

Description

Font$(x) should contain:

Chars 1-30: Font name (left justified, spaces padded right)
Chars 31-34: Font size (left justified, spaces padded right)

Chars 35-38: Font type (left justified, spaces padded right)

Problems:

1. Len(Font$(x)) should always be 38, but it's 39. (I'm guessing that the name has an extra space padded.)
2. There are 2 spaces at the beginning of the font size.

3. There are 2 spaces at the beginning of the font type.

4. The ".font' is not included in the font name.

5. The first letter of "rom" should be capitalized. (Rom)

6. There should be a space padded after Rom, like so: "Rom ".

7. The wrong fonts are coming up in the wrong order, with the wrong pixel heights.

Example:

#manifest: "amiga"

Screen Open 0,640,200,32,Hires
Get Fonts

For f=1 To 9
F$=Font$ (f)

FontName$=Mid$ (F$, 1, 30)
FontSize$=Mid$ (F$, 31, 4)
FontType$=Mid$ (F$, 35, 4)

Print "Font$ (";Right$(Strs$

Print "Font: [";FontName$;

Print "Size: [";FontSize$;

Print "Type: [";FontType$;
Next f

: Rem 1st 30 characters should be the font name
: Rem Characters 31-34 should be the font size
: Rem Characters 35-38 should be the font type
There should be 9 ROM fonts (1-9), in the following order, with the pixel heights shown below:

: topaz.font, 8

: topaz.font, 9
2001.font, 8

: broadway. font,
21
20
: News.font, 23

: Peridot.font, 7
32

16
lines. font,
: mFast.font,
: Pica.font,
Instead, now we're getting:
. broadway, 16
16
16
16
. peridot,
16

lines,
. mFast,
. News,
16
. Pica,
should be 38."
7. sapphire, 16

8. n/a
9. n/a
History

#1 - 02/28/2020 09:06 PM - Brian Flanagan
- Affected version changed from 0.9.4 to 0.9.5.1

Problems still exist in 0.9.5.1.

#2 - 07/22/2020 09:35 AM - Brian Flanagan
- Affected version changed from 0.9.5.1 to 0.9.9.3

Problem still exists in 0.9.9.3
In addition, now Get Fonts, Get ROM Fonts, Get Disk Fonts all fail.

#3 - 08/12/2020 08:47 AM - Brian Flanagan
- Affected version changed from 0.9.9.3 to 0.9.9.4

Problems still exist. (0.9.9.4 rel1)

#4 - 10/12/2020 12:42 PM - Brian Flanagan
- Estimated time set to 2:00 h
- Affected version changed from 0.9.9.4 to Beta RC3

We're now getting 9 fonts showing in the Amiga manifest, but they're still the wrong face & name.

0 2001 16 rom
1 broadway 16 rom
2 lines 16 rom
3 mFast 16 rom
4 News 16 rom
5 peridot 16 rom
6 Pica 16 rom
7 sapphire 16 rom
8 topaz 16 rom

#5 - 10/12/2020 12:44 PM - Brian Flanagan

that last comment should have read "wrong face & size"

#6 - 02/20/2021 07:34 AM - Brian Flanagan
- Affected version changed from Beta RC3 to 1.0.0 (B3)

Font$ is still pretty messed up in Amiga mode. The above problems still exist.
Summary:

The default font is wrong.

The fonts faces and sizes are wrong.

Referencing Font$(n) where n is > # of fonts -1 causes an Internal error.
Font$(0) should be an empty string.

The string returned by Font$ is incorrectly formatted. It should be:
Bytes 1-30: Font Name ( left justified, spaces padded right)

Bytes 31-34: Font Size ( left justified, spaces padded right)

Bytes 35-38: Font Type ( left justified, spaces padded right) Contains "Rom " or "Disc"
The Length of Font$(n) should ALWAYS be 38 (with format specified as above)
